import { Compiler, ExternalsElement, Plugin } from 'webpack';
import { BabelTarget } from './babel.target';
/**
 * @internalapi
 */
export declare class TargetingPlugin implements Plugin {
    private targets;
    private exclude;
    private readonly externals;
    private babelLoaderPath;
    private babelLoaders;
    private remainingTargets;
    private readonly doNotTarget;
    constructor(targets: BabelTarget[], exclude: RegExp[], doNotTarget: RegExp[], externals: ExternalsElement | ExternalsElement[]);
    apply(compiler: Compiler): void;
    private getBlindTarget;
    targetLazyModules(resolveContext: any): Promise<any>;
    targetModule(module: any): void;
    private targetDependency;
    targetDependencies(babelTarget: BabelTarget, context: any): void;
    afterResolve(resolveContext: any): Promise<void>;
    checkResolveTarget(resolveContext: any, hasLoader: boolean): void;
    replaceLoaders(resolveContext: any, loaders: any[]): void;
    isTargetedRequest(context: any, request: string): boolean;
    private isExternalRequest;
    isTargetedRequestContext(requestContext: any): Promise<boolean>;
    isTranspiledRequest(resolveContext: any): boolean;
    getTargetFromContext(context: any): BabelTarget;
    private getTargetedBabelLoader;
    private replaceLoader;
    static readonly loader: string;
    static readonly targetingLoader: string;
    private static readonly loaders;
}
